#' Scorecards function create simple scorecards by start date
#' 
#'@description function to create scorecards for single system and reference 
#'  combination, showing data by start date.
#'  


## Make function independent of previous functions
## For use with vreification suit and previous functions a wrapper will be developed

SC_plot_simple_odd <- function(data,
                               system.name,
                               reference.name,
                               variable,
                               start.date,
                               end.date,
                               forecast.months,
                               regions,
                               title){
  
  ### TO DO: 
  ## create layout of scorecard table
  ## define titles and headers
  ## apply colors to table
  ## create html table
  ## create color bars
  ## include color bars under table
  ## save each scorecard with unique name
  

  data <- aggregated_metrics ## Problem: attributes removed when array is filtered
  
  ## Define parameters of scorecard
  
  file_metric <- attributes(data)$metrics
  start.months <- attributes(data)$start.months
  regions.names <- names(attributes(data)$regions)
  forecast.months <- attributes(data)$forecast.months  
  reference.name <- attributes(data)$reference.name
  system.name <- attributes(data)$system.name[1] ## selecting only first system for testing
  start.year
  end.year
  
  n.start.months <- dim(data)["sdate"]
  n.ftime.months <- dim(data)["time"]
  n.metrics <- dim(data)["metric"]
  n.regions <- dim(data)["region"]
  
  metric.names <- ## get proper names from archive file
  
  ## Define table size
  
  n.table.rows <- n.regions * n.ftime.months
  n.table.columns <- 2 + (n.metrics * n.start.months)
  
  ## Define table names
  
  col.names <- c("Region", "Forecast month", rep(c(month.abb[as.numeric(start.months)]), n.metrics))
  
  row.names1 <- regions.names
  row.names2 <- rep(as.character(forecast.months), n.regions) 

  var.name <- ## paste0(toupper(substring(var.name, 1, 1)), substring(str_to_lower(var.name), 2, nchar(var.name)))
 
  options(stringsAsFactors = FALSE) 
  #header.names <- as.data.frame(data.frame(c1=c("", paste0("Mean Bias (", var.unit,")"), "Correlation", "CRPSS", "RPSS", "Spread-to-Error Ratio"), c2=c(2, rep(n.start.months, 5))))
  header.names1 <- as.data.frame(data.frame(c1=c("", file_metric), c2=c(2, rep(n.start.months, n.metrics)))) ## change file_metric to metric.names && need to include bias unit
  
  header.names2 <- data.frame(c1=paste0(var.name,  " of ", system.name), c2 = n.table.columns)
  
  ref.label <- data.frame(c1=paste0("(Ref: ", reference.name, " ", start.year, "-", end.year, ")"), c2 = n.table.columns)
  
  
  
  
  ## Define table layout
  
  
  ## create data.frame with all values to show in the scorecard:
  table.text <- data.frame(Forecast_month = forecast.month.figure)
 
  table <- cbind(table.text, bias.matrix, corr.matrix, crpss.matrix, rpss.matrix, enssprerr.matrix)
  
  
  
  ## Define table cell colors
  
  color.palette <- c('#2D004B', '#542789', '#8073AC', '#B2ABD2', '#D8DAEB', '#FEE0B6', '#FDB863', '#E08214', '#B35806', '#7F3B08')
  colorunder <- "#04040E" 
  colorsup <- "#730C04"
  
  
  ## Define html table
  
  
  
  
  
  
  
  
  
  # ## Table row titles
  # region.names.figure2 <- rep("", n.regions * n.ftime.months)
  # if(n.regions == 3) region.names2 <- region.names else region.names2 <- region.names[-1]
  # for(rr in 1:n.regions) region.names.figure2[floor(n.ftime.months/2) + (rr-1) * n.ftime.months ] = region.names2[rr]
  # for(rr in 1:n.regions) region.names.figure2[floor(n.ftime.months/2) + (rr-1) * n.ftime.months + 1] = region.names.figure[rr]
  # forecast.month.figure <- rep(1:n.ftime.months, n.regions)

  
  
  
  
}